.\"	$NetBSD: elanpar.4,v 1.3 2008/04/08 20:30:16 dyoung Exp $
.\"
.\"
.\" Copyright (c) 2008 David Young.  All rights reserved.
.\"
.\" Written by David Young.
.\"
.\" Redistribution and use in source and binary forms, with or
.\" without modification, are permitted provided that the following
.\" conditions are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above
.\"    copyright notice, this list of conditions and the following
.\"    disclaimer in the documentation and/or other materials
.\"    provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY DAVID YOUNG ``AS IS'' AND ANY
.\" EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
.\" THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A
.\" PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL DAVID
.\" YOUNG BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
.\" EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
.\" TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
.\" ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
.\" OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
.\" POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd January 10, 2008
.Dt elanpar 4 i386
.Os
.Sh NAME
.Nm elanpar
.Nd AMD Elan SC520 Programmable Address Regions
.Sh SYNOPSIS
.Cd "elansc* at mainbus? bus ?"
.Cd "elanpar* at elansc?"
.Sh DESCRIPTION
The
.Nm
driver supports the write-protect feature of the AMD
Elan SC520 microcontroller's integrated Programmable Address Regions.
Currently,
.Nm
protects the kernel text from being overwritten by the CPU or errant DMA.
.Sh DIAGNOSTICS
.Bl -diag
.It elanpar0: cpu violated write-protect window %u
.It elanpar0: gp violated write-protect window %u
.It elanpar0: pci violated write-protect window %u
.El
.Pp
A Programmable Address Region stopped
either the CPU, the general-purpose bus
.Pq gp ,
or a PCI bus master from writing to the indicated window of
write-protected memory.
.Bl -diag
.It elanpar0: %u bytes of kernel text are unprotected
.El
.Pp
.Nm
has not write-protected
.Em %u
bytes of the kernel text.
.Sh SEE ALSO
.Xr dmesg 8 ,
.Xr elanpex 4 ,
.Xr elansc 4 ,
.Xr syslogd 8 .
.Sh BUGS
.Pp
.Nm
leaves as many as 65535 bytes unprotected at the beginning and
end of kernel text.
Also,
.Nm
is not compatible with setting breakpoints
using
.Xr ddb 4 .
Disable
.Nm
using
.Ic drvctl Fl d Ar elanpar0
before setting a breakpoint with
.Xr ddb 4 .
.Sh HISTORY
The
.Nm
device first appeared in
.Nx 5.0 .
.Sh AUTHORS
The
.Nm
driver was written by
.An David Young Aq dyoung@NetBSD.org .
